package edu.dhbw.ma.pv;

public class Matrix {
    double[][] val;
    public Matrix(double[][] v) {
	val = v;
    }
    public Matrix difference(Matrix B) {
	double[][] res = new double[val.length][val[0].length];
	double[][] Bval = B.val;
	for (int i = 0; i < val.length; i++) {
	    for (int j = 0; j < val[0].length; j++) {
		res[i][j] = val[i][j] -  Bval[i][j]; 
	    }
	}
	return new Matrix(res);
    }
    public Matrix multiply(Matrix B) {
	double[][] res = new double[val.length][val[0].length];
	double[][] Bval = B.val; 
	for (int i = 0; i < val.length; i++) {
	    for (int j = 0; j < val[0].length; j++) {
		double s = 0.0;
		for (int k = 0; k < Bval[0].length; k++ ) {
		    s += val[i][k] * Bval[k][j];
		}
		res[i][j] = s; 
	    }
	}
	return new Matrix(res);
	}
    public static Matrix genOne(int n, int m) {
	double[][] res = new double[n][m];
	for (int i = 0; i < n; i++) {
	    for (int j = 0; j < m; j++) {
		if ( i == j ) {
		    res[i][j] = 1.0;
		} else {
		    res[i][j] = 0.0; 
		}
	    }
	}
	return new Matrix(res);
    }
    public static Matrix genZero(int n, int m) {
	double[][] res = new double[n][m];
	for (int i = 0; i < n; i++) {
	    for (int j = 0; j < m; j++) {
		res[i][j] = 0.0; 
	    }
	}
	return new Matrix(res);
    }
    public static Matrix genRandom(int n, int m) {
	double[][] res = new double[n][m];
	for (int i = 0; i < n; i++) {
	    for (int j = 0; j < m; j++) {
		res[i][j] = Math.random(); 
	    }
	}
	return new Matrix(res);
    }
    public Matrix transpose() {
	double[][] res = new double[val[0].length][val.length];
	for (int i = 0; i < val.length; i++) {
	    for (int j = 0; j < val[0].length; j++) {
		res[i][j] = val[j][i]; 
	    }
	}
	return new Matrix(res);
    }
    public static double epsilon = 10e-10;
    public boolean isNearlyZero() {
	for (int i = 0; i < val.length; i++) {
	    for (int j = 0; j < val[0].length; j++) {
		if ( Math.abs(val[i][j]) >= epsilon ) {
		    return false;
		} 
	    }
	}
	return true;
    }
    public String toString() {
	StringBuffer sb = new StringBuffer("\n");
	for (int i = 0; i < val.length; i++) {
	    for (int j = 0; j < val[0].length; j++) {
		sb.append(val[i][j] + " ");
	    }
	    sb.append("\n");
	}
	return sb.toString();
    }
}
