package edu.dhbw.ma.pv;

public class ParallelTransMatrix extends Matrix {
    public ParallelTransMatrix(double[][] d) {
   	super(d);    	
    }
    public Matrix multiply(Matrix B) {
	double[][] res = new double[val.length][val[0].length];
        Matrix C = new Matrix(res);
        Matrix Bt = B.transpose();
        Thread[] threads = new Thread[val.length];
	for (int i = 0; i < val.length; i++) {
	    threads[i] = new MultTransThread(C,this,Bt,i);
            threads[i].start();
	}
	for (int i =0; i < val.length; i++ ) {
	    try {
		threads[i].join();
	    } catch (InterruptedException e) {
		e.printStackTrace();
	    }
	}
	return C;
    }
}

class MultTransThread extends Thread {
    int i;
    Matrix A, B, C;
    public MultTransThread(Matrix C, Matrix A, Matrix B, int i) {
	//C = A*Bt
	this.i= i;
	this.A = A; this.B = B; this.C = C;
    }

    @Override
    public void run() {
    	double[][] val = A.val;
    	double[][] Bval = B.val;
    	double[][] res = C.val;
    	for (int j = 0; j < val[0].length; j++) {
            double s = 0.0;
	    for (int k = 0; k < Bval[0].length; k++ ) {
                s += val[i][k] * Bval[j][k]; // k,j
	    }
	    res[i][j] = s; 
	}
    }
}
