package edu.dhbw.ma.pv;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class Uebung4 {
    public static void main(String[] args) {
        ExecutorService pool = Executors.newCachedThreadPool();
        int ANZAHL = 10;
        Future<Long>[] zukunft = new Future[ANZAHL];
        for (int i = 0; i < ANZAHL; i++) {
            pool.execute( new Task4R(i) );
            zukunft[i] = pool.submit( new Task4C(i) );
        }
        for (int i = 0; i < ANZAHL; i++ ) {
            try {
                Long v = zukunft[i].get();
                System.out.println("zukünfiger wert von thread(" + i + ") = " + v);
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }
        pool.shutdown();
    }
}

class Task4R implements Runnable  {
    int num;
    public Task4R(int n) {
        num = n;
    }
    public String toString() {
        return "Task4R(" + num + ")";
    }
    public void run() {
        System.out.println("Thread " + this + " started");
        try {
            Thread.sleep((int)(Math.random()*10));
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        System.out.println("Thread " + this + " ended");
    }
}

class Task4C implements Callable<Long> {
    int num;
    public Task4C(int n) {
        num = n;
    }
    public String toString() {
        return "Task4C(" + num + ")";
    }
    public Long call() {
        System.out.println("Thread " + this + " started");
        try {
            Thread.sleep((int)(Math.random()*10));
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        System.out.println("Thread " + this + " ended");
        return new Long(num);
    }
}
