package edu.dhbw.ma.pv;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.atomic.AtomicLong;

public class Uebung5 {
    public static void main(String[] args) {
        ExecutorService pool = Executors.newCachedThreadPool();
        int ANZAHL = 10;
        AtomicLong zahl = new AtomicLong();
        Future<Long>[] zukunft = new Future[ANZAHL];
        for (int i = 0; i < ANZAHL; i++) {
            pool.execute( new Task5R(i,zahl) );
            zukunft[i] = pool.submit( new Task5C(i,zahl) );
        }
        for (int i = 0; i < ANZAHL; i++ ) {
            try {
                Long v = zukunft[i].get();
                System.out.println("zukünfiger wert von thread(" + i + ") = " + v);
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }
        pool.shutdown();
    }
}

class Task5R implements Runnable  {
    int num;
    AtomicLong zahl;
    public Task5R(int n, AtomicLong z) {
        num = n; zahl = z;
    }
    public String toString() {
        return "Task5R(" + num + ",zahl=" + zahl + ")";
    }
    public void run() {
        System.out.println("Thread " + this + " started");
        try {
            Thread.sleep((int)(Math.random()*10));
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        long z = zahl.incrementAndGet();
        System.out.println("Thread " + this + " ended, with z = " + z);
    }
}

class Task5C implements Callable<Long> {
    int num;
    AtomicLong zahl;
    public Task5C(int n, AtomicLong z) {
        num = n; zahl = z;
    }
    public String toString() {
        return "Task5C(" + num + ",zahl=" + zahl  + ")";
    }
    public Long call() {
        System.out.println("Thread " + this + " started");
        try {
            Thread.sleep((int)(Math.random()*10));
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        long z = zahl.incrementAndGet();
        System.out.println("Thread " + this + " ended, with z = " + z);
        return new Long(num+z);
    }
}
