package edu.dhbw.ma.pv;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.LinkedBlockingQueue;

public class Uebung6 {
    public static void main(String[] args) {
        ExecutorService pool = Executors.newCachedThreadPool();
        int ANZAHL = 10;
        //BlockingQueue<Arbeit> queue = new LinkedBlockingQueue<Arbeit>();
        BlockingQueue<Arbeit> queue = new ArrayBlockingQueue<Arbeit>(20);
        Future[]       zukunftR = new Future[ANZAHL];
        Future<Long>[] zukunftC = new Future[ANZAHL];
        for (int i = 0; i < ANZAHL; i++) {
            zukunftR[i] = pool.submit( new Task6R(i,queue) );
            zukunftC[i] = pool.submit( new Task6C(i,queue) );
        }
        for (int i = 0; i < ANZAHL; i++ ) {
            try {
                zukunftR[i].get();
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }       
        for (int i = 0; i < ANZAHL; i++ ) {
            try {
                queue.put( new Arbeit(-1)); // -1 = ende
            } catch (InterruptedException e) {
                e.printStackTrace();
            } finally {} 
        }
        for (int i = 0; i < ANZAHL; i++ ) {
            try {
                // so nicht: queue.put( new Arbeit(-1)); 
                Long v = zukunftC[i].get();
                System.out.println("zukünfiger wert von thread(" + i + ") = " + v);
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }
        System.out.println("queue.size() = " + queue.size());
        pool.shutdown();
    }
}

class Task6R implements Runnable  {
    int num;
    BlockingQueue<Arbeit> queue;
    public Task6R(int n, BlockingQueue<Arbeit> q) {
        num = n; queue = q;
    }
    public String toString() {
        return "Task6R(" + num + ")";
    }
    public void run() {
        System.out.println("Thread " + this + " started");
        try {
            Thread.sleep((int)(Math.random()*10));
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        for (int i = 1; i < num; i++ ) {
            try {
                queue.put( new Arbeit(num) );
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        System.out.println("Thread " + this + " ended");
    }
}

class Task6C implements Callable<Long> {
    int num;
    BlockingQueue<Arbeit> queue;
    public Task6C(int n, BlockingQueue<Arbeit> q) {
        num = n; queue= q;
    }
    public String toString() {
        return "Task6C(" + num + ")";
    }
    public Long call() {
        System.out.println("Thread " + this + " started");
        try {
            Thread.sleep((int)(Math.random()*10));
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        for (int i = 0; ; i++) {
            try {
                //if (queue.size() > 0) {
                Arbeit a = queue.take();
                if (a.get() < 0) {
                    System.out.println("received end: " + this);
                    break;
                }
                //}
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        System.out.println("Thread " + this + " ended");
        return new Long(num);
    }
}

class Arbeit {
    int a;
    public Arbeit(int i) {
        a = i;
    }
    int get() {
        return a;
    }
}
