package edu.dhbw.concurrent;

import jomp.runtime.*;

public class Beispiel3a {

    public static void main(String[] args) {
        int n = 1000;
        int m = n;
        Matrix A = new Matrix(n, m);
        Matrix B = Matrix.one(n);
        Matrix C = Matrix.random(n, m);

        // System.out.println("A: " + A);
        // System.out.println("B: " + B);
        // System.out.println("C: " + C);

        long ts = System.currentTimeMillis();
        Matrix E = C.mult(B);
        ts = System.currentTimeMillis() - ts;
        // System.out.println("E: " + E);

        MatrixParallel PC = new MatrixParallel(C.val);
        long tp = System.currentTimeMillis();
        Matrix pE = PC.mult(B);
        tp = System.currentTimeMillis() - tp;
        // System.out.println("pE: " + pE);

        MatrixTrans Pt = new MatrixTrans(C.val);
        long tt = System.currentTimeMillis();
        Matrix pT = Pt.mult(B);
        tt = System.currentTimeMillis() - tt;

        MatrixParallelTrans Ppt = new MatrixParallelTrans(C.val);
        long tpt = System.currentTimeMillis();
        Matrix ppT = Ppt.mult(B);
        tpt = System.currentTimeMillis() - tpt;

        MatrixOMPTrans Pot = new MatrixOMPTrans(C.val);
        long tot = System.currentTimeMillis();
        Matrix poT = Pot.mult(B);
        tot = System.currentTimeMillis() - tot;

        Matrix D = pE.diff(E);
        System.out.println("D ~= 0: " + D.isZero());
        System.out.println("Matrix = " + n + " x " + m);
        System.out.println("sequentiell              = " + ts + " ms");
        System.out.println("parallel                 = " + tp + " ms");
        System.out.println("sequentiell transponiert = " + tt + " ms");
        System.out.println("parallel transponiert    = " + tpt + " ms");
        System.out.println("OpenMP transponiert      = " + tot + " ms");
    }
}
