package edu.dhbw.concurrent;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;

public class Beispiel5 {
    static int worker = 5;
    static boolean done = false;

    public static void main(String[] args) throws InterruptedException {
        BlockingQueue<Auftrag> queue = new ArrayBlockingQueue<Auftrag>(100);
        Thread[] prod = new Thread[worker];
        Thread[] cons = new Thread[worker];
        for (int i = 0; i < worker; i++) {
            prod[i] = new Ueb5Prod(i, queue);
            cons[i] = new Ueb5Cons(i, queue);
            prod[i].start();
            cons[i].start();
        }
        System.out.println("Prod and Cons started");
        // falsch: queue.put(new Ende());
        for (int i = 0; i < worker; i++) {
            try {
                prod[i].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        done = true;
        queue.put(new Ende());
        System.out.println("Prod joined");
        for (int i = 0; i < worker; i++) {
            try {
                cons[i].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        System.out.println("Cons joined");
        queue.take(); // aufräumen
        System.out.println("#queue = " + queue.size());
    }

}

class Ueb5Prod extends Thread {
    BlockingQueue<Auftrag> queue;
    int i;

    Ueb5Prod(int i, BlockingQueue<Auftrag> q) {
        queue = q;
        this.i = i;
    }

    public void run() {
        System.out.println("Thread Ueb5Prod " + i + " started");
        for (int j = 0; j < 20; j++) {
            try {
                queue.put(new Auftrag(i * 100 + j));
                Thread.sleep((int) Math.random() * 300);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}

class Ueb5Cons extends Thread {
    BlockingQueue<Auftrag> queue;
    int i;

    Ueb5Cons(int i, BlockingQueue<Auftrag> q) {
        this.i = i;
        queue = q;
    }

    public void run() {
        System.out.println("Thread Ueb5Cons " + i + " started");
        for (int j = 0;; j++) {
            try {
                Auftrag x = null;
                // synchronized (queue) {
                // if (Beispiel5.done && queue.isEmpty()) {
                // break;
                // }
                // // x = queue.poll(100, TimeUnit.MILLISECONDS);
                // if (!queue.isEmpty()) {
                // x = queue.take();
                // }
                // }
                x = queue.take();
                if (x instanceof Ende) {
                    queue.put(x);
                    break;
                }
                if (x == null) {
                    continue;
                }
                System.out.println("Cons(" + i + "), x = " + x);
                Thread.sleep((int) Math.random() * 10);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }

    }
}

class Auftrag {
    int i;

    public Auftrag(int i) {
        this.i = i;
    }

    public String toString() {
        return "Auftrag(" + i + ")";
    }
}

class Ende extends Auftrag {
    public Ende() {
        super(-1);
    }
}
