package edu.dhbw.concurrent;

import mpi.MPI;
import mpi.MPIException;

/**
 */
public class BroadcastMPJ {

    static public void main(String[] args) throws MPIException {
        MPI.Init(args);

        int myrank = MPI.COMM_WORLD.Rank();
        int size = MPI.COMM_WORLD.Size();
        System.out.println("Running on node " + myrank + " of " + size
                + " total nodes");

        char[] message = new char[20];
        if (myrank == 0) {
            message = ("from " + myrank + ".").toCharArray();
        }
        MPI.COMM_WORLD.Bcast(message, 0, message.length, MPI.CHAR, 0);
        String msg = new String(message, 0, message.length);
        System.out.println("received '" + msg + "' at node " + myrank);

        int sum = 0;
        for (int i = 0; i < message.length; i++) {
            sum += message[i];
        }
        int[] sp = new int[1];
        sp[0] = sum;

        int[] rp = new int[1];
        MPI.COMM_WORLD.Reduce(sp, 0, rp, 0, 1, MPI.INT, MPI.SUM, 0);
        if (myrank == 0) {
            System.out.println("total sum = " + rp[0]);
        }

        MPI.Finalize();
    }
}
