package edu.dhbw.concurrent;

import mpi.MPI;
import mpi.MPIException;
import mpi.Status;


/**
 * HelloMPI.
 * @author from the MPI examples.
 */
public class HelloMPJ {


    static public void main(String[] args) throws MPIException {
        MPI.Init(args);

        int myrank = MPI.COMM_WORLD.Rank();
        int size = MPI.COMM_WORLD.Size();
        System.out.println("Running on node " + myrank + " of " + size + " total nodes");
        
        if (myrank == 0) {
            char[] message = ("Hello, from " + myrank + "." ).toCharArray();
            for (int i = 1; i < size; i++) {
                MPI.COMM_WORLD.Send(message, 0, message.length, MPI.CHAR, i, 99);
            }
            message = new char[30];
            for (int i = 1; i < size; i++) {
                Status stat = MPI.COMM_WORLD.Recv(message, 0, message.length, MPI.CHAR, i, 99);
                int count = stat.Get_count(MPI.CHAR); // stat.count
                String msg = new String(message, 0, count);
                System.out.println("received '" + msg + "' at node " + myrank + ", Status.count = " + count);
            }
        } else {
            char[] message = new char[20];
            Status stat = MPI.COMM_WORLD.Recv(message, 0, message.length, MPI.CHAR, 0, 99);
            int count = stat.Get_count(MPI.CHAR); // stat.count
            String msg = new String(message, 0, count);
            System.out.println("received '" + msg + "' at node " + myrank + ", Status.count = " + count);
            message = ("Hello back, from " + myrank + "." ).toCharArray();
            MPI.COMM_WORLD.Send(message, 0, message.length, MPI.CHAR, 0, 99);
            System.out.println("done send at " + myrank);
        }
        
        MPI.Finalize();
    }
}
