
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.FileNotFoundException ;
import java.util.Arrays;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.AbstractMap;
import java.util.stream.Stream;
import java.util.stream.Collectors;
import java.util.function.Function;


public class Histogram {

    public static void main(String[] args) throws FileNotFoundException {
        String file = "coding_style";
        
        Stream<String> seq = new BufferedReader(new FileReader(file)).lines(); 
        System.out.println("seq = " + seq);

        Stream<String> words = seq.flatMap(line -> Arrays.asList(line.split(" ")).stream());
        System.out.println("words = " + words);

        Stream<Map.Entry<String,Integer>> word1 = words.map(word -> new AbstractMap.SimpleEntry<String,Integer>(word,1));
        System.out.println("word1 = " + word1);

        //Stream<Map.Entry<String,Integer>> word2a = word1.sorted((a,b) -> a.getKey().compareTo(b.getKey()));
        //System.out.println("word2 = " + word2);
        //System.out.println("word2: ");
        //word2.forEach(a -> System.out.print(a.getKey() + " "));
        //System.out.println("");

        Map<String,List<Map.Entry<String,Integer>>> word2 = word1.collect(Collectors.groupingBy(Map.Entry::getKey));
        System.out.println("word2 = " + word2.getClass().getName());

        Stream<Map.Entry<String,Integer>> word3 = word2.entrySet().stream().map(e -> new AbstractMap.SimpleEntry<String,Integer>(e.getKey(), e.getValue().stream().collect( Collectors.summingInt(Map.Entry::getValue)) ) );
        System.out.println("word3 = " + word3);

        // non parallel only
        Stream<Map.Entry<String,Integer>> word4 = word3.sorted((a,b) -> a.getValue().compareTo(b.getValue()));
        System.out.println("word4 = " + word4);
        //System.out.println("word4: ");
        //word4.forEach(a -> System.out.print(a + " "));
        //System.out.println("");

        Map<String,Integer> histo = word4.collect( Collectors.toMap( e -> e.getKey(), e -> e.getValue() ) );
        ///Map<String,Integer> histo = word4.collect(  Collectors.toMap( Function.identity(), Function.identity() ) );
        System.out.println("histo = " + histo);
        System.out.println("histo = " + histo.getClass().getName());

        System.out.println("max(histo) = " + histo.entrySet().stream().collect( Collectors.maxBy( (a,b) -> a.getValue().compareTo(b.getValue()) ) ));
    }

}
