#ifndef ParMult_h
#define ParMult_h

struct seven_args {
    double* C;
    double* A;
    double* B;
    int m;
    int p;
    int n;
    int i;
};

/**
 * Parallel Matrix Multiplication. 
 * Using dim(A) number of threads.
 * @author Joachim Staats.
 */
class ParMult {
public:
/**
 * Performs the multiplication of two matrices.
 * C = A * B.
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
    void multiply(double* C, double* A, double* B, int m, int p, int n);
};

/**
 * It performs a row multiplication.
 */
void* RowMult (void *arg);

#endif
