#include "SeqMult.h"

#include <iostream>

using namespace std;

/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm.
 * @author Joachim Staats.
 */

/**
 * Performs the multiplication of two matrices.
 * C = A * B.
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
void SeqMult::multiply(double* C, double* A, double* B, int m, int p, int n) 
{
    cout << "SeqMult ";
    for (int i=0; i < m; ++i) {
        for (int j=0; j < n; ++j) {
            double c = 0.0;
            for (int k=0; k < p; ++k) {
                c += A[i*p+k] * B[k*n+j];
            }
            C[i*n+j] = c;
        }
    }
}
