#ifndef SeqMultBlock_h
#define SeqMultBlock_h

/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm, generating product matrix in blocks.  
 * @author Joachim Staats.
 */

class SeqMultBlock {
public:
/** 
 * Constructor.
 */
    SeqMultBlock(int size) : blocksize(size){};

/**
 * Performs the multiplication of two matrices.
 * C = A * B.
 * @param C matrix.
 * @param A matrix.
 * @param B double array.
 */
    void multiply(double* C, double* A, double* B, int m, int p, int n);

private:
    int blocksize;
};

#endif
