package measuretime

import (
	"fmt"
	"time"
)

type Timer struct {
	start       int64
	elapsedTime float64
}

func (t *Timer) Pre() {
	t.start = time.Now().UnixNano()
}

func (t *Timer) Post() float64 {
	delta := float64(time.Now().UnixNano()-t.start) * 1e-9
	t.elapsedTime = delta
	return delta
}

func (t Timer) PrintTimeConsumption(name string) {
	fmt.Printf("Consumed time in %s: %.3fs.\n", name, t.elapsedTime)
}
