import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.concurrent.Callable;

public class DistRunner {
    final static int PORT = 65000;
    public static void main(String[] args) 
        throws UnknownHostException, IOException {
        String host = "localhost";
        if (args.length > 0) {
            host = args[0];
        }
        ChannelFactory cf = new ChannelFactory(PORT+1);
        //Socket s = new Socket(host,PORT);
        //ObjectChannel oc = new ObjectChannel(s);
        ObjectChannel oc = cf.getChannel(host,PORT);
        System.out.println("connected to " + oc);
        while (true) {
            try {
                Object o = oc.receive();
                System.out.println("recieved " + o);
                if (o instanceof Schluss) {
                    break;
                }
                if (o instanceof Callable) {
                    Callable c = (Callable) o;
                    Object r = c.call();
                    System.out.println("o: " + o + ", r = " + r);
                    oc.send(r);
                }
                if (o instanceof Runnable) {
                    Runnable r = (Runnable) o;
                    r.run();
                    oc.send(r);
                }
            } catch (IOException e) {
                e.printStackTrace();
                break;
            } catch (ClassNotFoundException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        oc.close();
        cf.terminate();
    }

}
