//package edu.unima.ky.parallel;

/**
 * Finanz version A.
 * Multi threaded application generates transactions using 
 * objects from KontoA and displays results.
 * Uses synchronized Konto.
 * @author Heinz Kredel. 
 */ 

public class FinanzA {

/**
 * @param args
 */
    public static void main(String[] args) {

        for (int i=0; i < 10; i++) {
        KontoA a = new KontoA(0.0);
        KontoA b = new KontoA(2000);

        Thread t1 = new UeberweisungA(a,b,10.0); // a is the accont to get amount from.
        Thread t2 = new UeberweisungA(a,b,10.0); // b is account to add amount to.
                                                 // 10.0 is the amount to transfer.
        Thread t3 = new UeberweisungA(a,b,10.0); 
        Thread t4 = new UeberweisungA(b,a,30.0);

        t1.start(); t2.start(); t3.start(); t4.start();

        System.out.println("Stand a = " + a.zeigeGeld() +
                           " Stand b = " + b.zeigeGeld() );

        try {
            t1.join(); t2.join(); t3.join(); t4.join();
        } catch(InterruptedException e ) { }

        System.out.println("Endstand a = " + a.zeigeGeld() +
                           " Endstand b = " + b.zeigeGeld() );
        }
    }

}
