//package edu.unima.ky.parallel;

/** 
 * Hallo Welt Thread.
 * Multi threaded application processing and displaying "names" from 
 * threads while threads are sleeping for a random time.
 * @author Heinz Kredel. 
 */ 
public class HalloWeltThread {

    public static void main(String[] args) {

        String name = "Kily";
        if (args.length > 0 ) {
            name = args[0];
        }

        for (int i = 0; i < 1; i++ ) {
            System.out.println("Creating Threads ... ");
            Thread t1 = new Thread( new Tuwas("Michael") );
            Thread t2 = new Thread( new Tuwas("Karl") );
            Thread t3 = new Thread( new Tuwas(name) );

            System.out.println("Starting Threads ... ");
            t1.start(); t2.start(); t3.start(); 

            System.out.println("Waiting on Threads to terminate ... ");
            /*  test ohne join */
            try {
                t1.join(); t2.join(); t3.join(); 
            } catch(Exception e) { 
              System.out.println("Dies sollte nicht passieren "+e);
            }
            /*   */
            System.out.println("Threads joined");
            //System.exit(0); // test
        }
    }

}

/**
 * Object to be executed in a Thread. 
 */
class Tuwas implements Runnable {

    String var = "";

/** 
 * Konstructor.
 * @param v A String, the desired name.
 */
    public Tuwas(String v) {
        var = v;
    }

/** 
 * Runs five times per thread but sleeping a random time.
 */
     public void run() {
        for (int k = 0; k < 5; k++) {
            Work.schaffen(100);
            System.out.println("Hi " + var + " zum " + k + "-ten");      
        }
    }

}

/**
 * Random delay by working.
 */
class Work {

/** 
 * Random delay.
 * @param max the desired delay in ms.
 */
    public static void schaffen(int max) {
        try {
            Thread.currentThread().sleep( (int)(max*Math.random()) );
        } catch (InterruptedException e) {
              System.out.println("Dies sollte nicht passieren "+e);
        }

    }

}
