
/**
 * Konto interface.
 * Defindes methods to display, add and remove money from the account.
 * @author Heinz Kredel.
 */

public interface Konto {

    /**
     * zeigeGeld.
     * @return account.
     */
    public /*synchronized*/ double zeigeGeld();


    /**
     * putGeld.
     * @param b amount to be added.
     * @return account balance.
     */
    public /*synchronized*/ double putGeld(double b);


    /**
     * getGeld.
     * @param b amount to be withdrawn.
     * @return account balance.
     */
    public /*synchronized*/ double getGeld(double b);

}
