
/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm, generating product matrix in blocks
 * also blocking A and B.
 * @author Heinz Kredel.
 */

public class SeqMult4 implements MMInf {

    int blocksize = 1;

    public SeqMult4(int size) {
         this.blocksize = size;	
    }


/**
 * Performs the multiplication of two matrices.
 * C = A * B.
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
    public void multiply(double[][] C, double[][] A, double[][] B) {

      int na = blocksize;
      int nb = blocksize;
      int nc = blocksize;
      System.out.println("#blocks = " + (A.length/na) + ", na = " + na 
          + " SeqMultBlock4");

      for (int ii=0; ii < A.length; ii+=na) {
          for (int jj=0; jj < B[0].length; jj+=nb) {
              for (int kk=0; kk < B.length; kk+=nc) {

              for (int i=ii; i < Math.min((ii+na),A.length); i++) {
                  for (int j=jj; j < Math.min((jj+nb),B[0].length); j++) {
                      double c = C[i][j];
                      for (int k=kk; k < Math.min((kk+nc),B.length); k++) {
                          c += A[i][k] * B[k][j];
                      }
                      C[i][j] = c;
                  }
              }

              }
          }
      }

    }

}
