/**
 * Sequential Vector Scalar Multiplication. 
 * @author Heinz Kredel.
 */


public class SeqVSMult implements VSMInf {

/**
 * Computes the scalar multiplication of two vectors.
 * @param A Vector.
 * @param B Vector.
 */
    public double multiply(double[] A, double[] B) {
      double c = 0.0;
      for (int i=0; i < Math.min(A.length,B.length); i++) {
          c += A[i] * B[i];
      }
      return c;
    }

/**
 * Computes the norm of a vector.
 * @param A Vector.
 */
    public double norm(double[] A) {
      double c = 0.0;
      for (int i=0; i < A.length; i++) {
          c += A[i] * A[i];
      }
      return Math.sqrt(c);
    }

}
