
/**
 * A 2d Graph for an TSP Problem
 */

public class PlaneGraph extends Graph {

    public PlaneGraph(Point[] p) {
        super( p.length );
        for (int i = 0; i < p.length; i++ ) {
            for (int j = i+1; j < p.length; j++ ) {
                double dist = Math.sqrt( sqr( p[i].x - p[j].x )
                                       + sqr( p[i].y - p[j].y ) );
                connect(i,j,dist);
                connect(j,i,dist);
            }
        }
    }

    final double sqr(double s) { return s*s; }

}