
import java.io.Serializable;

/**
 * A Graph for an TSP Problem
 */

public class Graph implements Serializable {

    protected double[][] g;
    final static double INFINITY = Double.POSITIVE_INFINITY;

    public Graph(int n) {
        g = new double[n][n];
        for (int i = 0; i < n; i++ ) {
            connect(i,i,0.0);
            for (int j = i+1; j < n; j++ ) {
                connect(i,j,INFINITY);
                connect(j,i,INFINITY);
            }
        }
    }

    public void connect(int i, int j, double d) {
        g[i][j] = d;
    }

    public double distance(int i, int j) {
        return g[i][j];
    }

    public int size() {
        return g.length;
    }

}