use traits::ParallelExecution;

use std::thread;
use std::sync::mpsc;

pub struct ThreadedChannel{
    pub result: i64,
}

impl ThreadedChannel{
    pub fn new(start_value :i64) -> ThreadedChannel{
        ThreadedChannel{result: start_value}
    }
}

impl ParallelExecution for ThreadedChannel{
    fn run(& mut self ,num :i64, num_threads :i32) -> f64{
        let mut sum = 0 as f64;
        let size = num/num_threads as i64;
        let (tx,rx) = mpsc::channel();
        for i in 0i64..num_threads as i64{
            let txc = tx.clone();
            thread::spawn(move || {
                let mut temp_sum = 0 as f64;
                for n in (i*size)..((i+1)*size){
                    temp_sum += ((n*2)as f64).sin();
                }
                txc.send(temp_sum).unwrap();
            });
        }
        thread::spawn(move || {
            tx.send(0 as f64).unwrap();
        });

        for recv in rx {
            sum += recv;
        }
        sum
    }
}