package edu.dhbw.pv;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.LinkedBlockingQueue;

public class Aufgabe5 {
    public static void main(String[] args) {
        int anzahl = 1000;
        int tasks = 7;
        ExecutorService pool = Executors.newCachedThreadPool();
        //ExecutorService pool = Executors.newSingleThreadExecutor();
        Future<Double>[] pres = new Future[tasks]; 
        Future<Double>[] cres = new Future[tasks]; 
        //BlockingQueue<Item> queue = new ArrayBlockingQueue<Item>(300);
        BlockingQueue<Item> queue = new LinkedBlockingQueue<Item>();
        for (int j = 0; j < tasks; j++) {
            pres[j] = pool.submit( new Task5Prod(j, anzahl, queue) );
            cres[j] = pool.submit( new Task5Cons(j, queue) );
        }
        //pool.shutdown();
        double psumme = 0.0;
        double csumme = 0.0;
        for (int j = 0; j < tasks; j++) {
            try {
                psumme += pres[j].get();
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }
        for (int j = 0; j < tasks; j++) {
            try {
                queue.put( new Schluss() );
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        for (int j = 0; j < tasks; j++) {
            try {
                csumme += cres[j].get();
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }
        System.out.println("psumme = " + psumme);
        System.out.println("csumme = " + csumme);
        pool.shutdown();
    }
}

class Task5Prod implements Callable<Double> {
    int anzahl;
    int me;
    BlockingQueue<Item> queue;
    public Task5Prod(int m, int a, BlockingQueue<Item> q) {
        me = m;
        anzahl = a;
        queue = q;
    }
    public Double call() {
        double s = 0.0;
        System.out.println("p start " + me);
        for (int i = 0; i < anzahl; i++) {
            s += Math.sin(i);
        }
        System.out.println("p end " + me + " , s = " + s);
        try {
            queue.put( new Item(s) );
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        return new Double(s);
    }
}
class Task5Cons implements Callable<Double> {
    BlockingQueue<Item> queue;
    int me;
    public Task5Cons(int m, BlockingQueue<Item> q) {
        queue = q;
        me = m;
    }
    public Double call() throws InterruptedException {
        double s = 0.0;
        System.out.println("c start " + me);
        while (true) {
            Item el = queue.take();
            if (el instanceof Schluss) {
                break;
            }
            s += el.d;
        }
        System.out.println("c end " + me + ", s = " + s);
        return new Double(s);
    }
}
class Item {
    public double d;
    public Item() { }
    public Item(double d) {
        this.d = d;
    }
}
class Schluss extends Item {
}