package edu.dhbw.pv;

public class Matrix {
    double[][] val;
    public Matrix(int n, int m) {
        val = new double[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                val[i][j] = 0.0;
            }
        }
    }
    public Matrix(int n, int m, boolean unit) {
        val = new double[n][m];
        if (unit) {
            for (int i = 0; i < n; i++) { 
                for (int j = 0; j < m; j++) {
                    if (i == j) {
                        val[i][j] = 1.0;
                    } else {
                        val[i][j] = 0.0;
                    }
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    val[i][j] = Math.random()*10.0;
                }
            }
        }
    }
    public Matrix(double[][] v) {
        val = v;
    }
    public Matrix multiply(Matrix B) {
        Matrix ret = new Matrix(val.length, val[0].length);
        for (int i = 0; i < val.length; i++) {
            for (int j = 0; j < val[0].length; j++) {
                double s = 0.0;
                for (int k = 0; k < val[0].length ; k++) {
                    s += val[i][k] * B.val[k][j];
                }
                ret.val[i][j] = s;
            }
        }
        return ret;
    }
    public String toString() {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < val.length; i++) {
            for (int j = 0; j < val[0].length; j++ ) {
                sb.append(val[i][j] + " ");
            }
            sb.append("\n");
        }
        return sb.toString();
    }
    public boolean equals(Matrix B) {
        for (int i = 0; i < val.length; i++) {
            for (int j = 0; j < val[0].length; j++ ) {
                if (val[i][j] != B.val[i][j]) {
                    return false;
                }
            }
        }
        return true;
    }
    public Matrix transpose() {
        Matrix ret = new Matrix(this.val[0].length, this.val.length);
        for (int i = 0; i < val.length; i++) {
            for (int j = 0; j < val[0].length; j++) {
                ret.val[j][i] = val[i][j];
            }
        }
        return ret;  
    }
}
