package edu.dhbw.pv;

public class ParallelTransposeMatrix extends Matrix {
    public ParallelTransposeMatrix(int n, int m) {
        super(n, m);
    }
    public ParallelTransposeMatrix(int n, int m, boolean u) {
        super(n, m, u);
    }
    public ParallelTransposeMatrix(double[][] v) {
        super(v);
    }
    public Matrix multiply(Matrix B) {
        Matrix ret = new Matrix(val.length, val[0].length);
        Matrix Bt = B.transpose();
        Thread[] threads = new Thread[val.length];
        for (int i = 0; i < val.length; i++) {
            threads[i] = new ZeileMultTranspose(ret.val, val, Bt.val,i);
            threads[i].start();
        }
        for(int i = 0; i < val.length; i++ ) {
            try {
                threads[i].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        return ret;
    }
}
class ZeileMultTranspose extends Thread {
    double[][] Cv;
    double[][] Av;
    double[][] Bv;
    int i;
    public ZeileMultTranspose(double[][] C, double[][] A, double[][] B, int i) {
        Cv = C; Av = A; Bv = B; this.i = i; 
    }
    //@Override
    public void run() {
        for (int j = 0; j < Bv.length; j++) {
            double s = 0.0;
            for (int k = 0; k < Bv[0].length ; k++) {
                s += Av[i][k] * Bv[j][k]; // war k,j
            }
            Cv[i][j] = s;
        }
    }
}
